﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _3AlgCzyLiczbaDoskonala
{
    public partial class Form1 : Form
    {
        private bool czy_jest_doskonala(long n)
        {
            long suma = 1,//stan początkowy sumy
                p = (long)Math.Floor(Math.Sqrt(n));//pierwiastek z podanje liczby
            //szukaj w zakresie do pierwiastka z podanje liczby
            for (long i = 2; i <= p; i++)
                if (n % i == 0)//czy dzielnik
                    suma += i + n / i;//jak tak to dodaj dwa dzielniki
            //sprawdz czy była to liczba kwadratowa
            //jak tak, to odejmij pierwiastek, bo go wczśniej dodaliśmy dwa razy
            if (n == p * p) suma -= p;
            //gdy suma dzielnikow jest rowna liczbie to doskonla
            if(n==suma)return true;
            return false;
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length < 1) return;
            long  n=Int64.Parse(textBox1.Text);
            if (czy_jest_doskonala(n))
                MessageBox.Show(
                    "To jest liczba doskonała",
                    "Komunikat",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                    );
            else MessageBox.Show(
                    "To nie jest liczba doskonała",
                    "Komunikat",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                    );
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 8) return;//wyskocz na BackSpace
            if (e.KeyChar < '0' || e.KeyChar > '9') e.Handled = true;//ignoruj nienumeryczne
        }
    }
}
